;--------------------------------------------------------------------------
; Cviceni 2 z predmetu IAS
;--------------------------------------------------------------------------
;	Principy programovani v assembleru a zakladni ridici
;	struktury (if ... else, for, while, do ... while, case).
;--------------------------------------------------------------------------
; ZADANI:
;	V kodu, ktery nasleduje, jsou funkce, ktere nemaji telo. Vasim
;	ukolem je, tyto funkce vytvorit tak, aby splnovaly popis uvedeny
;	v zahlavi kazde z nich. V pripade nejasnosti se ptejte cvicicich.
;	
; HODNOCENI:
;	1 bod za funkcni 'if...else', 'for', 'while' a 'do...while'
;	1 bod za funkcni 'case'
;
; KONTROLNI HODNOTY:
;
;	Zadejte na vstup retezec: 'abcd-a-B-c-d'
;
; VYSTUPEM BY MELY BYT NASLEDUJICI UDAJE:
;
;	Zadejte retez znaku: abcd-a-B-c-d
;	Skutecna delka zadaneho retezce: 12
;	Delka zadaneho retezce (vase funkce 'Length'): 12
;	Zadali jste retezec (vase funkce 'Print'): abcd-a-B-c-d
;	Kopie retezce (vase funkce 'CopyString'): abcd-a-B-c-d
;	Zpracovavam retezec (vase funkce 'ParseString'). Nalezene parametry:
;	Zadali jste parametr -a.
;	Zadali jste parametr -b.
;	Zadali jste parametr -c.
;	Zadali jste neznamy parametr: -d
;
;--------------------------------------------------------------------------

	bits 16
	%include "rw.asm"

	segment code
;--------------------------------------------------------------------------
IsEmpty:
;
; Procviceni struktury IF...ELSE
;
; Vstup:
;		DX = offset retezce ukonceneho cislem 0
; Vystup:
;		CL = 1 = retezec je prazdny
;		CL = 0 = retezec neni prazdny
;
; Napiste funkci, ktera zjisti, zda je retezec na adrese dane offsetem v DX
; prazdny nebo ne. Je-li prazdny, CL = 1, jinak CL = 0.
;
; Pouzijte konstrukci typu: 'if (podminka) { ... } else { ... }'

	; Zde bude vas kod

push bx

mov bx, dx
mov al, [bx]
cmp al, 0
jne @neni_prazdny
mov cl, 1
jmp @if_konec
@neni_prazdny:
mov cl, 0
@if_konec:

pop bx

    	ret
;--------------------------------------------------------------------------
Length:
;
; Procviceni cyklu WHILE
;
; Vstup:
;		DX = offset retezce ukonceneho cislem 0
; Vystup:
;		CX = delka retezce
;
; Napiste funkci, ktera spocita vsechny znaky retezce na adrese dane
; offsetem DX. Retezec je ukoncen CISLEM 0. Vyslednou delku retezce ulozte do
; registru CX.
;
; Pouzijte konstrukci typu: 'while (podminka) { ... }'

push bx

mov bx, dx

mov cx, 0
@while:
mov al, [ds:bx]
cmp al, 0
je @while_end
inc cx
inc bx
jmp @while
@while_end:

pop bx

	; Zde bude vas kod
	
    	ret
;--------------------------------------------------------------------------
Print:
;
; Procviceni cyklu FOR
;
; Vstup:
;		DX = offset zadaneho retezce znaku
;		CX = pocet znaku retezce
;		
; Vystup:
;		Retezec vypsany na obrazovce monitoru.
;
; Napiste proceduru, ktera vytiskne vsechny znaky retezce ulozeneho na
; adrese dane offsetem DX. Retezec ma CX znaku.
;
; K tisku znaku pouzijte funkci Write_Char, ktera tiskne znak ulozeny 
; v registru AL.
;
; Pocet prvku retezce je ulozen v registru CX.
;
; Pouzijte konstrukci typu:
;
; 'for (i = 0; i < CX; i++) { ... }' ... pro vypis jednotlivych znaku

push bx

mov bx, dx
@for_loop:
mov al, [ds:bx]
call Write_Char
inc bx
loop @for_loop

pop bx

	; Zde bude vas kod
	
	ret
;--------------------------------------------------------------------------
CopyString:
;
; Procviceni struktury cyklu DO { ... } WHILE
;
; Vstup:
;		SI = offset zdrojoveho retezce znaku (ukoncen cislem 0)
;		DI = offset ciloveho retezce - misto, kam budete kopirovat
; Vystup:
;		Na adrese dane v DI bude kopie retezce z SI.
;		
;	Napiste funkci, ktera zkopiruje retezec znaku ukonceny cislem 0, 
;	ulozeny na offsetu danem v SI do mista daneho offsetem v DI.
;	Nezapomente, ze zdrojovy retezec je ukoncen 0 a cilovy by mel byt
;	taktez ukoncen nulou, proto pouzijte 'do...while'.
;
; Pouzijte konstrukci typu 'do { ... } while (podminka)'
	
	; Zde bude vas kod

@do_copystr:
mov al, [ds:si]
mov [ds:di], al

inc si
inc di

cmp al, 0
jne @do_copystr

	ret
;--------------------------------------------------------------------------
ParseString:
;
; Procviceni struktury typu CASE
;
; Vstup:
;		DX = offset zadaneho retezce ukonceneho cislem 0
; Vystup:
;		Vystupy na obrazovku (funkce 'option_x'). Dle zadanych parametru.
;
; Napiste proceduru na zpracovani retezce znaku. Vstupni retezec muze obsahovat
; libovolne znaky. Pokud naleznete shluk znaku '-a','-A','-b''-B','-c' nebo '-C',
; tak zavolejte prislusnou funkci 'option_a', 'option_b', 'option_c' nebo
; 'option_unknown' narazite-li na parametr, ktery neznate (tj. napr. '-X').
;
; Pouzijte jakykoliv typ cyklu a konstrukci 'switch (x) { case 1: ...; case 2: ...; }'.
; Tj. pouzijte hodne 'if-else' konstrukci...

	; Zde bude vas kod ... doufam :-)

push bx

mov ah, 0	; v ah bude vzdy predchozi pismeno

mov bx, dx

@do_2nd:

mov al, [bx]

cmp ah, 45	; '-' = 45
jne @skip_test

and al, 223	; 223 = ~32 -> zvetsuje to pismeny
cmp al, 65	; 65 = 'A'
jne @next_test_a
call option_a
jmp @skip_test

@next_test_a:

cmp al, 66	; 66 = 'B'
jne @next_test_b
call option_b
jmp @skip_test

@next_test_b:

cmp al, 67	; 67 = 'C'
jne @next_test_c
call option_c
jmp @skip_test

@next_test_c:

mov al, [bx]		; nechci tomu predelavat velikost pismeny ...
call option_unknown	; neco jineho ... a v al je hodnota parametru

@skip_test:

mov ah, al	; predchozi ...
inc bx

cmp al, 0
jne @do_2nd

pop bx

	ret
;--------------------------------------------------------------------------
; Pomocne funkce - nemenit, prosim
;--------------------------------------------------------------------------
option_a:
	pusha
	mov dx,_msg_option_a
	call Print_Str
	popa
	
	ret
;--------------------------------------------------------------------------
option_b:
	pusha
	mov dx,_msg_option_b
	call Print_Str
	popa
	
	ret
;--------------------------------------------------------------------------
option_c:
	pusha
	mov dx,_msg_option_c
	call Print_Str
	popa
	
	ret
;--------------------------------------------------------------------------
option_unknown:
; v AL by mela byt hodnota zvoleneho parametru
	pusha
	mov dx,_msg_option_unknown
	call Print_Str
	push ax
	mov al,'-'
	call Write_Char
	pop ax
	call Write_Char
	call WriteLn
	popa
	
	ret
;--------------------------------------------------------------------------
;
; Hlavni cast programu.
; V teto casti nic nemente (muzete, ale az bude funkcnost predvedena cvicicimu)!!!!
; Doplnte kod jednotlivych fuknci.
;	
..start:

	prologue
	
	mov dx,_input_string		; precist retezec a ulozit znaky na
	call Read_String		; adresu 'input_string' - 1. byte
	call WriteLn			; udava delku retezce
	
	movzx si,byte [_input_string]	; na konec retezce dame cislo 0
	mov al,0
	mov [_input_string + 1 + si],al
	inc dx				; 1. byte zadaneho retezce ignorujeme,
					; pze je v nem ulozena delka retezce,
	xor cl,cl			; vunulujeme CL (otestujeme vasi funkci),
	call IsEmpty			; zjistime, je-li retezec prazdny pomoci
	cmp cl,1			; vasi funkce 'IsEmpty'
	jz StringIsEmpty		; je-li cl = 1, retezec je prazdny => koncime

	call Length			; vypocitame delku retezce (pouzijeme vami
					; vytvorenou funkci 'Length')

	mov dx,_msg_real_str_len	; pro jistotu vypiseme skutecnou delku
	call Print_Str			; retezce (pro kontrolu)
	mov al,[_input_string]
	call Write_Byte
	call WriteLn

	mov dx,_msg_str_len		; vypocitanou delku vypiseme na obrazovku
	call Print_Str
	mov ax,cx
	call Write_Integer
	call WriteLn

	mov dx,_msg_input_string	; vypiseme obsah zadaneho retezce na
	call Print_Str			; obrazovku	
	mov dx,_input_string + 1	; k tomu pouzijeme vami vytvorenou
	call Print			; funkci 'Print'
	call WriteLn
	
	mov si,_input_string + 1	; zkopirujeme retezec '_input_string' do
	mov di,_copy			; mista '_copy' a pouzijeme vasi
	call CopyString			; funkci 'CopyString'
	
	mov dx,_msg_copy_string
	call Print_Str
	mov dx,_copy
	call Length
	call Print
	call WriteLn
	
	mov dx,_msg_parse_string	; zpracujeme retezec
	call Print_Str
	mov dx,_input_string + 1
	call ParseString		; najdeme vsechny parametry
					; ('-a', '-A', ...)
					; pomoci vasi funkce 'ParseString'
	jmp Exit

StringIsEmpty:
	mov dx,_msg_empty
	call Print_Str

Exit:
	epilogue
;--------------------------------------------------------------------------
	segment data

_msg_read_string	db	"",'$'
_msg_option_a		db	"Zadali jste parametr -a.",13,10,'$'
_msg_option_b		db	"Zadali jste parametr -b.",13,10,'$'
_msg_option_c		db	"Zadali jste parametr -c.",13,10,'$'
_msg_option_unknown	db	"Zadali jste neznamy parametr: $"
_msg_input_string	db	"Zadali jste retezec (vase funkce 'Print'): $"
_msg_copy_string	db	"Kopie retezce (vase funkce 'CopyString'): $"
_msg_str_len		db	"Delka zadaneho retezce (vase funkce 'Length'): $"
_msg_real_str_len	db	"Skutecna delka zadaneho retezce: $"
_msg_parse_string	db	"Zpracovavam retezec (vase funkce 'ParseString'). Nalezene parametry:",13,10,'$'
_msg_empty		db	"Vstupni retezec je prazdny!!!",13,10,'$'
_string_len		db	0
_input_string		resb 2048
			db	0,'$'
_copy			db	"Kopie.",0,'$'
			resb 2048
